/* 
 * File:   FRR_Functions.h
 * Author: John
 *
 * Created on March 20, 2018, 2:38 PM
 */

void FRR_Routine(void);
void deployRoutine(void);
void moveRover(void);
void deploySolarPanels(void);
void config_outputCompare(void);
void prepareForFlight(void);
void armRover(void);
void function_that_does_something_with_data(unsigned char data[received_string_length-received_data_offset]);

void deployRoutine(void) {
    DEPLOY_Timer_Prescale_8;
    DEPLOY_Timer_Period = 20000;
    MEASURE_Timer_Prescale_256;
    MEASURE_Timer_Period = 2500;
    MEASURE_Timer_On = true;
    DEPLOY_Timer_On = true;
}

void deploySolarPanels(void) {
    PWM_Timer_On = true;
    OC2CONbits.ON = true;
    MEASURE_Timer_On = true;
}
void config_outputCompare(void) {
    OC2CONbits.ON = 0;
    OC2RS = 1872;
    OC2R = 1872;
    OC2CONbits.OC32 = 0;
    OC2CONbits.OCTSEL = 0;
    OC2CONbits.OCM = 0b110;
}
void prepareForFlight(void){
    PWM_Timer_On = true;
    OC2CONbits.ON = true;
    
  
}
void function_that_does_something_with_data(unsigned char data[received_string_length-received_data_offset]) {
 //printf("Received data: %s\r\n",data);
 switch (data[0]) {
     case 'C':
         if(data[1] == '1') {
             DEPLOY_Timer_On = false;
             MEASURE_Timer_On = false;
             DRIVE_Timer_On = false;
             OC2RS = 1872;
             LIGHT_POWDER1 = high;
//             LIGHT_POWDER1 = low;
         }
         else if (data[1] == '2') {
             DEPLOY_Timer_On = false;
             MEASURE_Timer_On = false;
             DRIVE_Timer_On = false;
             OC2RS = 1872;
             LIGHT_POWDER2 = high;
//             LIGHT_POWDER2 = low;
         }
         break;
     case 'D':
         if (data[1] == '1') {
             DEPLOY_Timer_On = false;
             MEASURE_Timer_On = false;
             DRIVE_Timer_On = false;
             OC2RS = 1872;
             driveForward();
             MEASURE_TIMER_CONDITION = 2;
             COUNT_SECONDS = 0;
             MEASURE_Timer_Period = 60000;
             MEASURE_Timer_On = true;

         }
         else if (data[1] == '2') {
             DEPLOY_Timer_On = false;
             MEASURE_Timer_On = false;
             DRIVE_Timer_On = false;
             OC2RS = 1872;
             MEASURE_TIMER_CONDITION = 3;
             deployRoutine();
         }
         else if (data[1] == '3') {
             DEPLOY_Timer_On = false;
             MEASURE_Timer_On = false;
             DRIVE_Timer_On = false;
             OC2RS = 1872;
             coast();
         }
         break;
     case 'A':
         DEPLOY_Timer_On = false;
         MEASURE_Timer_On = false;
         DEPLOY_Timer_On = false;
         MEASURE_Timer_On = false;
         DRIVE_Timer_On = false;
         OC2RS = 1872;
         if (data[1] == '1'){
            DEPLOY_Timer_On = false;
            MEASURE_Timer_On = false;
            DRIVE_Timer_On = false;
            OC2RS = 1807;
         }
         if (data[1] == 'F') {
             SWITCH_COMMAND = 2;
            DEPLOY_Timer_On = false;
            MEASURE_Timer_On = false;
            DRIVE_Timer_On = false;
            OC2RS = 1872;   
            DRIVE_Timer_On = true;
            newDataRead = false;    
//            GPS_RESET = 1;
            GPS_UART_Receive_Interrupt_Enable = 1;
         }
         if (data[1] == '5') {
             SWITCH_COMMAND = 0;
            DEPLOY_Timer_On = false;
            MEASURE_Timer_On = false;
            DRIVE_Timer_On = false;
            OC2RS = 1935; 
            MEASURE_TIMER_CONDITION = 4;
            MEASURE_Timer_Period = 29000;
            MEASURE_Timer_On = true;
            
         }
         if (data[1] == '9') {
            DEPLOY_Timer_On = false;
            MEASURE_Timer_On = false;
            DRIVE_Timer_On = false;
            OC2RS = 1872; 
         }
         if (data[1] == 'D') {
            DEPLOY_Timer_On = false;
            MEASURE_Timer_On = false;
            DRIVE_Timer_On = false;
            OC2RS = 1935; 
            MEASURE_TIMER_CONDITION = 4;
            MEASURE_Timer_Period = 65000;
            MEASURE_Timer_On = true;
         }
         break;

     default:
         printf("Unexpected Command");
 }
 
 lora_transceiver_state = IDLE_LoRa;
}