/* 
 * File:   driveFunctions.h
 * Author: John
 *
 * Created on February 20, 2018, 11:12 AM
 */

void motorTest(void);
void motorAForward(void);
void motorABackward(void);
void motorBForward(void);
void motorBBackward(void);
void motorCFoward(void);
void motorCBackward(void);
void motorDForward(void);
void motorDBackward(void);
void driveForward(void);
void driveBackward(void);
void turnRight(void);
void turnLeft(void);
void driveSetup(void);

void coast(void);
void motorTest(void) {
    MEASURE_Timer_On = true;
    DRIVE_Timer_On = true;
    PWM_Timer_On = true;
    
}
void motorABackward(void){
    MOTOR_A1 = 0;
    MOTOR_A2 = 1;
}
void motorAForward(void) {
    MOTOR_A2 = 0;
    MOTOR_A1 = 1;
}
void motorBForward(void){
    MOTOR_B1 = 0;
    MOTOR_B2 = 1;
}
void motorBBackward(void) {
    MOTOR_B2 = 0;
    MOTOR_B1 = 1;
}
void motorCBackward(void) {
    MOTOR_C2 = 0;
    MOTOR_C1 = 1;
}
void motorCForward(void) {
    MOTOR_C1 = 0;
    MOTOR_C2 = 1;
}
void motorDBackward(void) {
    MOTOR_D1 = 0;
    MOTOR_D2 = 1;
}
void motorDForward(void) {
    MOTOR_D2 = 0;
    MOTOR_D1 = 1;
}
void coast(void) {
    MOTOR_A1 = 0;
    MOTOR_A2 = 0;
    MOTOR_B1 = 0;
    MOTOR_B2 = 0;
    MOTOR_C1 = 0;
    MOTOR_C2 = 0;
    MOTOR_D1 = 0;
    MOTOR_D2 = 0;
    SWITCH_MODE = 4;
}

void driveForward(void) {
    if (!SLOW_MOTOR) {
        motorAForward();
        motorBForward();
        motorCForward();
        motorDForward();
    }
    else {
        coast();
    }
    SWITCH_MODE = 0;
}
void driveBackward(void) {
    if (!SLOW_MOTOR) {
        motorABackward();
        motorBBackward();
        motorCBackward();
        motorDBackward();
    }
    else {
        coast();
    }
    SWITCH_MODE = 1;
}

void turnLeft(void) {
    motorABackward();
    motorBForward();
    motorCForward();
    motorDBackward();
    SWITCH_MODE = 2;
}

void turnRight(void) {
    motorAForward();
    motorBBackward();
    motorCBackward();
    motorDForward();
    SWITCH_MODE = 3;
}
void driveSetup(void) {
    int distance = 0xFFFF;
    distance = readLidar();
    if (distance < 100) {
        turnLeft();      
    }
    else {
        driveForward();
    }
        
}