/* 
 * File:   lidarHeader.h
 * Author: John
 *
 * Created on February 4, 2018, 2:12 PM
 */

#define numCounts 500
void initializeLidar(void);
int readLidar(void);
int readLidar(void){
    int disCount = 0;
    unsigned char byte;
    unsigned char check = 0xFF;
    unsigned char disHigh;
    unsigned char disLow;
    initializeLidar();
    while (check != 0x00){
        startI2C();
        putI2C(lidar_write & 0xFE);
        putI2C(0x01);
        stopI2C();
        startI2C();
        putI2C(lidar_read | 0x01);
        byte = getI2C(1);
        check = byte & 0b00000001;
        stopI2C();
    }
    startI2C();
    putI2C(lidar_write & 0xFE);
    putI2C(0x8f);
    stopI2C();
    startI2C();
    putI2C(lidar_read | 0x01);
    disHigh = getI2C(0);
    disLow = getI2C(1);
    int distance = disHigh << 8 | disLow;
    printf("Current distance from target is %d cm \n\r",distance);
    stopI2C();
    return distance;
}
void initializeLidar(void) {//initialize LIDAR and get first reading
    startI2C();
    putI2C(lidar_write & 0xFE);
    putI2C(0x00); //write device command
    putI2C(0x04); //take distance measurement without receiver bias correction
    stopI2C();
}