/* 
 * File:   mainProgram.c
 * Author: John
 *
 * Created on December 13, 2017, 11:03 AM
 */
#include "config.h"
#include <xc.h>
#include "SDlib16_delay.h"
#include "config_pins.h"
#include "config_general_macros.h"
#include "config_addresses.h"
#include "uart_config.h"
#include "lora_config.h"
#include "timer_config.h"
#include "driveFunctions.h"
#include "interrupt_config.h"
#include "I2C_function.h"
#include "lidarHeader.h"
#include "BLE_functions.h"
#include "setup_devices_file.h"  
#include "GAM_header.h"
#include "altimeter_header.h"
#include "interrupt_config_UART.h"
#include "interrupt_config_UART_LoRa.h"
//#include "interrupt_config_UART_GPS.h"
#include "interrupt_config_UART_GPS_VER2.h"
#include "FRR_Functions.h"
/*
 * 
 */

void GPSTest(void);

int main(int argc, char** argv) {
    unsigned char GPSchar;
    int i;
    configure_uart();
    setup_devices();
    configI2C();
    configure_interrupts();
    configure_timers();
    config_outputCompare();
    //initializeGAM();
    //initializeAlt();
    PWM_Timer_On = true;
    OC2CONbits.ON = true;
    MEASURE_Timer_On = true;
    
     GPSTest();    
//    while (true) {
//        LoRa();
//    }
    while(true){
        if (newDataRead == true) {
            LORA_nRESET = high;
            LoRa();
        }

        
    }
    return (EXIT_SUCCESS);
}
void GPSTest(void) {
    setGPS();
}
